#ifndef _NVRAM_
#define _NVRAM_
/*
 * 2003/02/27  		             			    
 * 		       				released by Ron     
 */

/* line terminator by 0x00 
 * data terminator by two 0x00
 * value separaed by 0x01
 */	

/* nvram path */
#ifndef TEST
#define NVRAM_PATH     "/dev/mtd1"          /* ex:  /dev/mtd/nvram */
#else
#define NVRAM_PATH     "/tmp/nvramall"            /* ex:  /dev/mtd/nvram */
#endif

#define NVRAM_TMP_PATH "/tmp/nvram"		  /* ex:  /tmp/nvram     */
#define NVRAM_BCM_PATH "/tmp/nvram.bcm"
#define NVRAM_DEFAULT  "/etc/default"             /* ex:  /etc/default   */
#define NVRAM_JFFS2_PATH "/etc/nvram"

#define END_SYMBOL	    0x00		  	
#define DIVISION_SYMBOL	    0x01		  

/* NVRAM_HEADER MAGIC*/ 
#define NVRAM_MAGIC 		    0x004E4F52		 /* RON */

/* used 12bytes, 28bytes reserved */
#define NVRAM_HEADER_SIZE   40       		 
/* max size in flash*/
//#define NVRAM_SIZE          65535		  /* nvram size 64k bytes*/
#define NVRAM_SIZE              0x10000

/* each line max size*/
#define NVRAM_BUFF_SIZE           4096		 

/* errorno */
#define NVRAM_SUCCESS       	    0
#define NVRAM_FLASH_ERR           1 
#define NVRAM_MAGIC_ERR	    2
#define NVRAM_LEN_ERR	    3
#define NVRAM_CRC_ERR	    4
#define NVRAM_SHADOW_ERR	    5

/*
 * nvram header struct 		            
 * magic    = 0x004E4F52 (RON)             
 * len      = 0~65495                      
 * crc      = use crc-32                    
 * reserved = reserved 	                    
 */
 
typedef struct nvram_header_s{
	unsigned long magic;
	unsigned long len;
	unsigned long crc;
	unsigned long reserved;
	
}nvram_header_t;


#endif
