#ifndef _DOWNLOAD_H_
#define _DOWNLOAD_H_

#define LAN_PORT				"br0"
#define WAN_PORT				"eth2.2"

#define xchgs(x)                (WORD)((((WORD)((WORD)x)&0x0ff)<<8)|(((WORD)((WORD)x)&0x0ff00)>>8))
#define PACKET_SIZE             512
#define DL_ACK_LEN              80

#define PACKED                  __attribute__((packed))

#define  GET_VERSION_INFO       0x0000
#define  DOWN_REQUEST           0x0001
#define  DOWN_DATA              0x0002
#define  DOWN_RESET             0x0003
#define  DOWN_VERIFY            0x0004
#define  DOWN_EALL              0x0005

enum {
    WAIT_GET_VERSION,
    PROGRAM_FLASH,
    VERIFY_FLASH
};


/*
 *  Display an MAC address with ARRAY format in readable format.
 */

#define NMACQUAD(addr) \
	((unsigned char *)addr)[0], \
	((unsigned char *)addr)[1], \
	((unsigned char *)addr)[2], \
	((unsigned char *)addr)[3], \
	((unsigned char *)addr)[4], \
	((unsigned char *)addr)[5]


#ifdef _MIPS_
union unalign
{
    DWORD	dw;
    WORD	w;
} __attribute__((packed));

static inline WORD GetWord(VOID * buf)
{
    union unalign	*u = buf;

    return u->w;
}

static inline DWORD GetDword(VOID * buf)
{
    union unalign	*u = buf;

    return u->dw;
}

static inline VOID SetWord(void * buf, WORD wValue)
{
    union unalign	*u = buf;

    u->w = wValue;
}

static inline VOID SetDword(void * buf, DWORD dwValue)
{
    union unalign	*u = buf;

    u->dw = dwValue;
}
#endif

typedef struct{
    BYTE dbDestAddress[6];
    BYTE dbSrcAddress[6];
    WORD dwID;
    WORD dwCmd;
    WORD dwSeq;
    WORD dwOff;
    WORD dwSeg;
    WORD dwLen;
    BYTE dbData[PACKET_SIZE];
}PACKED DOWNLOADHead;

#endif /* _DOWNLOAD_H_ */

